// ********************************************************************************************************************
//  File Name				: VipCommunicate.cpp
//  Description				: ZIPCOϐ}I/Fwb_t@CiVCpj
// ********************************************************************************************************************


// ********************************************************************************************************************
//							Include Section
// ********************************************************************************************************************
#include "stdafx.h"
#include "ZVipPnlImp.h"
#include "VipCommunicate.h"
#include "VipUpdateData.h"

// ********************************************************************************************************************
//							Grobal Value Definition Section
// ********************************************************************************************************************


// ********************************************************************************************************************
//							Local Value Definition Section
// ********************************************************************************************************************
static HINSTANCE		hDLLInst	= NULL;											// "ZVipPnl.DLL"W[̃nh
static UINT				uiPnlMsg	= RegisterWindowMessage(VIP_PNL_MESSAGE);		// VIPʐMpMessageID
static CVipUpdateData	UpdateData;													// XVf[^

// ********************************************************************************************************************
//							CVipCommunicate NX o֐
// ********************************************************************************************************************

// ********************************************************************************************************************
// Function Name			: GetDllInst
// Description				: "ZVipPnl.DLL"W[̃nh擾
// Return Code				: "ZVipPnl.DLL"W[̃nh
// ********************************************************************************************************************
HINSTANCE GetDllInst( void )
{
	return hDLLInst;
}


// ********************************************************************************************************************
// Function Name			: VIP_LoadPnlIF
// Description				: ZVipPnl.DLL[h
// Return Code				: s
// Parameter				: strFileihZVipPnl.DLLht@Cj
// ********************************************************************************************************************
BOOL VIP_LoadPnlIF( CString strFile )
{
	//	ZVipPnl.DLLǂݍ
	hDLLInst = AfxLoadLibrary( strFile );

	//	Ƀ[hꂽH
	BOOL bRet = FALSE;
	if( hDLLInst != NULL ) {
		bRet = TRUE;
	}
	else {
		// none
	}

	return	bRet;
}


// ********************************************************************************************************************
// Function Name			: VIP_LoadPnlIF
// Description				: ZVipPnl.DLLJ
// ********************************************************************************************************************
void VIP_FreePnlIF(void)
{
	//	ZVipPnl.DLLǂݍ܂Ă邩H
	if( hDLLInst != NULL ) {
		//	ZVipPnl.DLL
		AfxFreeLibrary(hDLLInst);
	}
	else {
		// none
	}
	hDLLInst = NULL;

	return;
}


// ********************************************************************************************************************
// Function Name			: VIP_PnlConnect
// Description				: ZIPC VIPƒʐMڑs
// Return					: s
// ********************************************************************************************************************
BOOL VIP_PnlConnect( LPCSTR lpszClassName, HWND hWnd )
{
	BOOL	bRet = FALSE;

	//	DLL[hĂ邩H
	HINSTANCE ahDLLInst = GetDllInst();
	if( ahDLLInst != NULL ) {
		//	Np֐AhX擾łH
		ZVIP_LINKCONNECT lpLinkConnection = (ZVIP_LINKCONNECT)GetProcAddress( ahDLLInst, _T("ZVIP_LinkConnection") );
		if( lpLinkConnection != NULL ) {
			//	Ns
			bRet = lpLinkConnection( lpszClassName, hWnd );
		}
		else {
			// none
		}
	}
	else {
		// none
	}

	return	bRet;
}


// ********************************************************************************************************************
// Function Name			: VIP_PnlCut
// Description				: ZIPC VIPƒʐMؒfs
// Return					: s
// ********************************************************************************************************************
BOOL VIP_PnlCut( LPCSTR lpszClassName, HWND hWnd )
{
	BOOL	bRet = FALSE;

	//	DLL[hĂ邩H
	HINSTANCE	ahDLLInst	= GetDllInst();
	if( ahDLLInst != NULL ) {
		//	Np֐AhX擾łH
		ZVIP_LINKCUT lpLinkCut = (ZVIP_LINKCUT)GetProcAddress( ahDLLInst, _T("ZVIP_LinkCut") );
		if( lpLinkCut != NULL ) {
			//	Ns
			bRet = lpLinkCut( lpszClassName, hWnd );
		}
		else {
			// none
		}
	}
	else {
		// none
	}

	return	bRet;
}


// ********************************************************************************************************************
// Function Name			: VIP_SetPortData
// Description				: |[gɃf[^ݒ肷
// Return					: s
// ********************************************************************************************************************
BOOL VIP_SetPortData( long nNo, LPVOID pData, long nParam )
{
	BOOL	bRet = FALSE;

	//	DLL[hĂ邩H
	HINSTANCE	ahDLLInst	= GetDllInst();
	if( ahDLLInst != NULL ) {
		//	Np֐AhX擾łH
		ZVIP_SETPORTIDDATA lpSetPortData = (ZVIP_SETPORTIDDATA)GetProcAddress( ahDLLInst, _T("ZVIP_SetPortIDData") );
		if( lpSetPortData != NULL ) {
			//	Ns
			bRet = lpSetPortData( nNo, pData, nParam );
		}
		else {
			// none
		}
	}
	else {
		// none
	}

	return	bRet;
}


// ********************************************************************************************************************
// Function Name			: VIP_GetWindowMessageID
// Description				: ZIPC VIPʐMpMessageID擾
// Return					: VIPʐMpMessageID
// ********************************************************************************************************************
UINT VIP_GetWindowMessageID(void)
{
	//	VIPʐMpMessageIDԂ
	return	uiPnlMsg;
}


// ********************************************************************************************************************
// Function Name			: VIP_PnlMessageProc
// Description				: ZIPC VIPƂ̒ʐMe͂s
// Return					: s
// Parameter				: wParamibZ[WWPARAMlj
// 							: lParamibZ[WLPARAMlj
// ********************************************************************************************************************
BOOL VIP_PnlMessageProc( WPARAM wParam, LPARAM lParam )
{
	//	Mf[^͂
	return	UpdateData.VipMessage( wParam, lParam );
}


// ********************************************************************************************************************
// Function Name			: VIP_IsUpdateData
// Description				: ʐMef[^XVł邱ƂmF
// Return					: mF
// ********************************************************************************************************************
BOOL VIP_IsUpdateData(void)
{
	return	UpdateData.IsUpdateData();
}


// ********************************************************************************************************************
// Function Name			: VIP_IsReset
// Description				: MeZbgʒmł邱ƂmF
// Return					: mF
// ********************************************************************************************************************
BOOL VIP_IsReset( void )
{
	return	UpdateData.IsReset();
}


// ********************************************************************************************************************
// Function Name			: VIP_GetUpdateMode
// Description				: XV̑擾
// Return					: XV̑
// ********************************************************************************************************************
enum ZIPCVIP_DATAMODE VIP_GetUpdateMode(void)
{
	return UpdateData.GetUpdateMode();
}


// ********************************************************************************************************************
// Function Name			: VIP_GetUpdateIndex
// Description				: XV̍ڔԍ擾
// Return					: XV̍ڔԍ
// ********************************************************************************************************************
int VIP_GetUpdateIndex( void )
{
	return UpdateData.GetUpdateIndex();
}


// ********************************************************************************************************************
// Function Name			: VIP_GetUpdateData
// Description				: XV̎f[^擾
// Return					: XV̎f[^
// ********************************************************************************************************************
void* VIP_GetUpdateData(void)
{
	return UpdateData.GetUpdateData();
}

// ********************************************************************************************************************
// Function Name			: VIP_SendNameEvent
// Description				: ̃Cxg𔭍s
// Return					: s
// Parameter				: strTaskis^XŃj
// 							: strEventisCxǵj
// ********************************************************************************************************************
BOOL VIP_SendNameEvent( CString strTask, CString strEvent )
{
	BOOL	bRet = FALSE;

	//	DLL[hĂ邩H
	HINSTANCE	ahDLLInst	= GetDllInst();
	if( ahDLLInst != NULL ) {
		ZVIP_SENDNAMEEVENT lpSendNameEvent = (ZVIP_SENDNAMEEVENT)GetProcAddress( ahDLLInst, _T("ZVIP_SendNameEvent") );
		if( lpSendNameEvent != NULL ) {
			if( !strTask.IsEmpty() ) {
				if( !strEvent.IsEmpty() ) {
					bRet = lpSendNameEvent( strTask.GetBuffer(strTask.GetLength()+1), strEvent.GetBuffer(strEvent.GetLength()+1) );
				}
				else {
					// none
				}
			}
			else {
				// none
			}
		}
		else {
			// none
		}
	}
	else {
		// none
	}

	return	bRet;
}


// ********************************************************************************************************************
// Function Name			: VIP_SetAngData
// Description				: AiOɃf[^ݒ肷
// Return					: s
// Parameter				: nNoiAiOڔԍj
// 							: dDataiݒf[^j
// ********************************************************************************************************************
BOOL VIP_SetAngData( long nNo, double dData )
{
	BOOL	bRet = FALSE;

	//	DLL[hĂ邩H
	HINSTANCE	ahDLLInst	= GetDllInst();
	if( ahDLLInst != NULL ) {
		//	Np֐AhX擾łH
		ZVIP_SETANGIDDATA lpSetAngData = (ZVIP_SETANGIDDATA)GetProcAddress( ahDLLInst, _T("ZVIP_SetAngIDData") );
		if( lpSetAngData != NULL ) {
			//	Ns
			bRet = lpSetAngData( nNo,  dData);
		}
		else {
			// none
		}
	}
	else {
		// none
	}

	return	bRet;
}


// ********************************************************************************************************************
// Function Name			: VIP_SetStrData
// Description				: Ƀf[^ݒ肷
// Return					: s
// Parameter				: nNoi񍀖ڔԍj
// 							: pDataii[AhXj
// 							: nParami񒷁j
// ********************************************************************************************************************
BOOL VIP_SetStrData( long nNo, LPCSTR pData, long nParam )
{
	BOOL	bRet = FALSE;

	//	DLL[hĂ邩H
	HINSTANCE	ahDLLInst	= GetDllInst();
	if( ahDLLInst != NULL ) {
		//	Np֐AhX擾łH
		ZVIP_SETSTRINGIDDATA lpSetStringData = (ZVIP_SETSTRINGIDDATA)GetProcAddress( ahDLLInst, _T("ZVIP_SetStringIDData") );
		if( lpSetStringData != NULL ) {
			//	Ns
			bRet = lpSetStringData( nNo, pData, nParam );
		}
		else {
			// none
		}
	}
	else {
		// none
	}

 	return	bRet;
}


// ********************************************************************************************************************
// Function Name			: VIP_SetVipTimer
// Description				: V~[V^C}[ݒ肷
// Return					: s
// Parameter				: nTimerIDiTimerIDj
// 							: ulHiTimeiݒ莞ԁF32bitj
// 							: ulLoTimeiݒ莞ԁF32bitj
// ********************************************************************************************************************
BOOL VIP_SetVipTimer( long nTimerID, unsigned long ulHiTime, unsigned long ulLoTime )
{
	BOOL	bRet = FALSE;

	//	DLL[hĂ邩H
	HINSTANCE	ahDLLInst	= GetDllInst();
	if( ahDLLInst != NULL ) {
		//	Np֐AhX擾łH
		ZVIP_SETTIMER lpSetTimer = (ZVIP_SETTIMER)GetProcAddress( ahDLLInst, _T("ZVIP_ SetTimer") );
		if( lpSetTimer != NULL ) {
			//	Ns
			bRet = lpSetTimer( nTimerID, ulHiTime, ulLoTime );
		}
		else {
			// none
		}
	}
	else {
		// none
	}

	return bRet;
}


// ********************************************************************************************************************
// Function Name			: VIP_SetVipTimer
// Description				: V~[V^C}[
// Return					: s
// Parameter				: nTimerIDiTimerIDj
// ********************************************************************************************************************
BOOL VIP_KillVipTimer( long nTimerID )
{
	BOOL	bRet = FALSE;

	//	DLL[hĂ邩H
	HINSTANCE	ahDLLInst	= GetDllInst();
	if( ahDLLInst != NULL ) {
		//	Np֐AhX擾łH
		ZVIP_KILLTIMER lpKillTimer = (ZVIP_KILLTIMER)GetProcAddress( ahDLLInst, _T("ZVIP_ KillTimer") );
		if( lpKillTimer != NULL ) {
			//	Ns
			bRet = lpKillTimer( nTimerID );
		}
		else {
			// none
		}
	}
	else {
		// none
	}

	return bRet;
}


// ********************************************************************************************************************
// Function Name			: VIP_GetTimerId
// Description				: TimerID擾
// Return					: TimerID
// ********************************************************************************************************************
int VIP_GetTimerId( void )
{
	return UpdateData.GetTimerId();
}






